#ifndef STRALLOC_H
#define STRALLOC_H

struct shared
{
  char *next;

#ifndef STRALLOC_GC
  int refs;
#ifdef DEBUG
  int extra_ref;
#endif
#endif
  int size;
  char str[1]; /* Must be last */
};

#define REFERENCE(X,Y) (BASEOF(X,shared,str)Y)

#define SIZE(X) REFERENCE(X,->size)
#define REFS(X) REFERENCE(X,->refs)
#define STR(X) REFERENCE(X,->str)
#define XREF(X) REFERENCE(X,->extra_ref)
#define NEXT(X) REFERENCE(X,->next)

#ifndef DEBUG
#define my_strlen(s) SIZE((s)->u.string)

extern INLINE char * copy_shared_string(char *str)
{
  extern int allocd_strings,allocd_bytes;
#ifndef STRALLOC_GC
  REFS(str)++;
#endif
  allocd_strings++;
  allocd_bytes += 4 + ((SIZE(str) + 3) & ~3);
  return(str);
}
#else
int my_strlen(const struct svalue *s);
#endif /* DEBUG */

char *make_shared_string PROT((const char *));
char *copy_shared_string PROT((char *));
INLINE int my_strcmp(const struct svalue *a,const struct svalue *b);
INLINE int my_string_is_equal(const struct svalue *a,const struct svalue *b) ATTRIBUTE((const));

void free_string PROT((char *));
char *findstring(const char *);
char *make_shared_binary_string(const char *str,int len);
char *debug_findstring(const char *foo);
char *begin_shared_string(int len);
char *end_shared_string(char *s);
char *add_string_status PROT((int verbose));
void uninit_strings(void);
void stralloc_gc(int);
extern int ref_cycle;

#endif /* STRALLOC_H */
